diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc	2025-06-01 20:34:45.641702400 -0700
@@ -3938,14 +4298,14 @@
         // At the end of the transmission, verify that a single RX start notification shall have
         // been notified when the reception of the first HE RB PPDU starts.
         Simulator::Schedule(expectedPayloadEnd,
-                            &TestUlOfdmaPhyTransmission::CheckApRxStart,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckApRxStart,
                             this,
                             1,
                             Simulator::Now() + expectedPayloadStart);
         // After the reception (hence we add 1ns to expectedPayloadEnd), a single RX end
         // notification shall have been notified when the reception of the last HE RB PPDU ends
         Simulator::Schedule(expectedPayloadEnd + NanoSeconds(1),
-                            &TestUlOfdmaPhyTransmission::CheckApRxEnd,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckApRxEnd,
                             this,
                             1,
                             Simulator::Now() + expectedPayloadEnd,
@@ -3955,45 +4315,49 @@
     delay += MilliSeconds(100);
     // Check reception state from STA 1
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::CheckRxFromSta1,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckRxFromSta1,
                         this,
                         expectedSuccessFromSta1,
                         expectedFailuresFromSta1,
                         expectedBytesFromSta1);
     // Check reception state from STA 2
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::CheckRxFromSta2,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckRxFromSta2,
                         this,
                         expectedSuccessFromSta2,
                         expectedFailuresFromSta2,
                         expectedBytesFromSta2);
     // Verify events data have been cleared
-    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::VerifyEventsCleared, this);
+    Simulator::Schedule(delay,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::VerifyEventsCleared,
+                        this);
 
     delay += MilliSeconds(100);
-    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::Reset, this);
+    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::Reset, this);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::SchedulePowerMeasurementChecks(Time delay,
-                                                           Watt_u rxPowerNonOfdmaRu1,
-                                                           Watt_u rxPowerNonOfdmaRu2,
-                                                           Watt_u rxPowerOfdmaRu1,
-                                                           Watt_u rxPowerOfdmaRu2)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SchedulePowerMeasurementChecks(
+    Time delay,
+    Watt_u rxPowerNonOfdmaRu1,
+    Watt_u rxPowerNonOfdmaRu2,
+    Watt_u rxPowerOfdmaRu1,
+    Watt_u rxPowerOfdmaRu2)
 {
     const auto detectionDuration = WifiPhy::GetPreambleDetectionDuration();
-    const auto txVectorSta1 = GetTxVectorForHeTbPpdu(1, 1, 0);
-    const auto txVectorSta2 = GetTxVectorForHeTbPpdu(2, 2, 0);
-    const auto hePhy = m_phyAp->GetHePhy();
-    const auto nonOfdmaDuration = hePhy->CalculateNonHeDurationForHeTb(txVectorSta2);
-    NS_ASSERT(nonOfdmaDuration == hePhy->CalculateNonHeDurationForHeTb(txVectorSta1));
+    const auto txVectorSta1 = GetTxVectorForTbPpdu(1, 1, 0);
+    const auto txVectorSta2 = GetTxVectorForTbPpdu(2, 2, 0);
+    const auto phyEntity = DynamicCast<OfdmaTestPhy<LatestPhyEntityType>>(m_phyAp->GetPhyEntity());
+    const auto nonOfdmaDuration = phyEntity->CalculateNonHeDurationForHeTb(txVectorSta2);
+    NS_ASSERT(nonOfdmaDuration == phyEntity->CalculateNonHeDurationForHeTb(txVectorSta1));
 
     std::vector<Watt_u> rxPowerNonOfdma{rxPowerNonOfdmaRu1, rxPowerNonOfdmaRu2};
-    std::vector<WifiSpectrumBandInfo> nonOfdmaBand{hePhy->GetNonOfdmaBand(txVectorSta1, 1),
-                                                   hePhy->GetNonOfdmaBand(txVectorSta2, 2)};
+    std::vector<WifiSpectrumBandInfo> nonOfdmaBand{phyEntity->GetNonOfdmaBand(txVectorSta1, 1),
+                                                   phyEntity->GetNonOfdmaBand(txVectorSta2, 2)};
     std::vector<Watt_u> rxPowerOfdma{rxPowerOfdmaRu1, rxPowerOfdmaRu2};
-    std::vector<WifiSpectrumBandInfo> ofdmaBand{hePhy->GetRuBandForRx(txVectorSta1, 1),
-                                                hePhy->GetRuBandForRx(txVectorSta2, 2)};
+    std::vector<WifiSpectrumBandInfo> ofdmaBand{phyEntity->GetRuBandForRx(txVectorSta1, 1),
+                                                phyEntity->GetRuBandForRx(txVectorSta2, 2)};
 
     for (uint8_t i = 0; i < 2; ++i)
     {
@@ -4004,13 +4368,13 @@
         Simulator::Schedule(
             delay + detectionDuration +
                 NanoSeconds(1), // just after beginning of portion (once event is stored)
-            &TestUlOfdmaPhyTransmission::CheckNonOfdmaRxPower,
+            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckNonOfdmaRxPower,
             this,
             m_phyAp,
             nonOfdmaBand[i],
             rxPowerNonOfdma[i]);
         Simulator::Schedule(delay + nonOfdmaDuration - NanoSeconds(1), // just before end of portion
-                            &TestUlOfdmaPhyTransmission::CheckNonOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckNonOfdmaRxPower,
                             this,
                             m_phyAp,
                             nonOfdmaBand[i],
@@ -4018,14 +4382,14 @@
         // Check received power on OFDMA portion
         Simulator::Schedule(delay + nonOfdmaDuration +
                                 NanoSeconds(1), // just after beginning of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phyAp,
                             ofdmaBand[i],
                             rxPowerOfdma[i]);
         Simulator::Schedule(delay + m_expectedPpduDuration -
                                 NanoSeconds(1), // just before end of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phyAp,
                             ofdmaBand[i],
@@ -4040,13 +4404,13 @@
         Simulator::Schedule(
             delay + detectionDuration +
                 NanoSeconds(1), // just after beginning of portion (once event is stored)
-            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
             this,
             m_phySta3,
             nonOfdmaBand[i],
             rxPowerNonOfdma[i]);
         Simulator::Schedule(delay + nonOfdmaDuration - NanoSeconds(1), // just before end of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phySta3,
                             nonOfdmaBand[i],
@@ -4054,14 +4418,14 @@
         // Check received power on OFDMA portion
         Simulator::Schedule(delay + nonOfdmaDuration +
                                 NanoSeconds(1), // just after beginning of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phySta3,
                             ofdmaBand[i],
                             rxPowerOfdma[i]);
         Simulator::Schedule(delay + m_expectedPpduDuration -
                                 NanoSeconds(1), // just before end of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phySta3,
                             ofdmaBand[i],
@@ -4083,13 +4447,13 @@
         Simulator::Schedule(
             delay + detectionDuration +
                 NanoSeconds(1), // just after beginning of portion (once event is stored)
-            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
             this,
             m_phySta2,
             nonOfdmaBand[0],
             rxPowerNonOfdmaSta1Only);
         Simulator::Schedule(delay + nonOfdmaDuration - NanoSeconds(1), // just before end of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phySta2,
                             nonOfdmaBand[0],
@@ -4097,14 +4461,14 @@
         // Check received power on OFDMA portion
         Simulator::Schedule(delay + nonOfdmaDuration +
                                 NanoSeconds(1), // just after beginning of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phySta2,
                             ofdmaBand[0],
                             rxPowerOfdma[0]);
         Simulator::Schedule(delay + m_expectedPpduDuration -
                                 NanoSeconds(1), // just before end of portion
-                            &TestUlOfdmaPhyTransmission::CheckOfdmaRxPower,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower,
                             this,
                             m_phySta2,
                             ofdmaBand[0],
@@ -4112,9 +4476,12 @@
     }
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::RunOne()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::RunOne()
 {
+    NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
+
     RngSeedManager::SetSeed(1);
     RngSeedManager::SetRun(1);
     int64_t streamNumber = 0;
@@ -4123,24 +4490,24 @@
     m_phySta2->AssignStreams(streamNumber);
     m_phySta3->AssignStreams(streamNumber);
 
+    const auto standard =
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_STANDARD_80211ax : WIFI_STANDARD_80211be;
     auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
                                                          m_frequency,
                                                          m_channelWidth,
-                                                         WIFI_STANDARD_80211ax,
-                                                         WIFI_PHY_BAND_5GHZ)
+                                                         standard,
+                                                         WIFI_PHY_BAND_6GHZ)
                           ->number;
 
-    m_phyAp->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
-    m_phySta1->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
-    m_phySta2->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
-    m_phySta3->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
+    const auto operatingChannel{
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_6GHZ, 0}};
+    m_phyAp->SetOperatingChannel(operatingChannel);
+    m_phySta1->SetOperatingChannel(operatingChannel);
+    m_phySta2->SetOperatingChannel(operatingChannel);
+    m_phySta3->SetOperatingChannel(operatingChannel);
 
     Time delay;
-    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::Reset, this);
+    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::Reset, this);
     delay += Seconds(1);
 
     /**
@@ -4154,7 +4521,7 @@
     //---------------------------------------------------------------------------
     // Verify that both solicited HE TB PPDUs have been corrected received
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Reception of solicited HE TB PPDUs");
     ScheduleTest(delay,
@@ -4173,7 +4540,7 @@
     // corrected received
     Simulator::Schedule(
         delay,
-        &TestUlOfdmaPhyTransmission::LogScenario,
+        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
         this,
         "Reception of solicited HE TB PPDUs with delay (< 400ns) between the two signals");
     ScheduleTest(delay,
@@ -4192,7 +4559,7 @@
     //---------------------------------------------------------------------------
     // Verify that no unsolicited HE TB PPDU is received
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Dropping of unsolicited HE TB PPDUs");
     ScheduleTest(delay,
@@ -4212,7 +4579,7 @@
     //---------------------------------------------------------------------------
     // Verify that HE TB PPDUs with channel width differing from TRIGVECTOR are discarded
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Dropping of HE TB PPDUs with channel width differing from TRIGVECTOR");
     ScheduleTest(delay,
@@ -4233,7 +4600,7 @@
     //---------------------------------------------------------------------------
     // Verify that HE TB PPDUs with UL Length differing from TRIGVECTOR are discarded
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Dropping of HE TB PPDUs with UL Length differing from TRIGVECTOR");
     ScheduleTest(delay,
@@ -4254,7 +4621,7 @@
     //---------------------------------------------------------------------------
     // Verify that HE TB PPDUs with AIDs differing from TRIGVECTOR are discarded
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Dropping of HE TB PPDUs with AIDs differing from TRIGVECTOR");
     ScheduleTest(delay,
@@ -4277,7 +4644,7 @@
     // impacted
     Simulator::Schedule(
         delay,
-        &TestUlOfdmaPhyTransmission::LogScenario,
+        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
         this,
         "Reception of solicited HE TB PPDUs with interference on RU 1 during PSDU reception");
     // A strong non-wifi interference is generated on RU 1 during PSDU reception
@@ -4293,8 +4660,8 @@
     Watt_u interferencePower{0.1};
     *interferencePsdRu1 = interferencePower / (MHzToHz(m_channelWidth / 2) * 20);
 
-    Simulator::Schedule(delay + MicroSeconds(50),
-                        &TestUlOfdmaPhyTransmission::GenerateInterference,
+    Simulator::Schedule(delay + MicroSeconds(40),
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::GenerateInterference,
                         this,
                         interferencePsdRu1,
                         MilliSeconds(100));
@@ -4316,7 +4683,7 @@
     // impacted
     Simulator::Schedule(
         delay,
-        &TestUlOfdmaPhyTransmission::LogScenario,
+        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
         this,
         "Reception of solicited HE TB PPDUs with interference on RU 2 during PSDU reception");
     // A strong non-wifi interference is generated on RU 2 during PSDU reception
@@ -4330,8 +4697,8 @@
     Ptr<SpectrumValue> interferencePsdRu2 = Create<SpectrumValue>(SpectrumInterferenceRu2);
     *interferencePsdRu2 = interferencePower / (MHzToHz(m_channelWidth / 2) * 20);
 
-    Simulator::Schedule(delay + MicroSeconds(50),
-                        &TestUlOfdmaPhyTransmission::GenerateInterference,
+    Simulator::Schedule(delay + MicroSeconds(40),
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::GenerateInterference,
                         this,
                         interferencePsdRu2,
                         MilliSeconds(100));
@@ -4354,7 +4721,7 @@
     // Generate an interference on the full band and verify that both solicited HE TB PPDUs have
     // been impacted
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Reception of solicited HE TB PPDUs with interference on the full band "
                         "during PSDU reception");
@@ -4369,8 +4736,8 @@
     Ptr<SpectrumValue> interferencePsdAll = Create<SpectrumValue>(SpectrumInterferenceAll);
     *interferencePsdAll = interferencePower / (MHzToHz(m_channelWidth) * 20);
 
-    Simulator::Schedule(delay + MicroSeconds(50),
-                        &TestUlOfdmaPhyTransmission::GenerateInterference,
+    Simulator::Schedule(delay + MicroSeconds(40),
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::GenerateInterference,
                         this,
                         interferencePsdAll,
                         MilliSeconds(100));
@@ -4393,13 +4760,13 @@
     // solicited HE TB PPDUs have been impacted if they are on the same
     // 20 MHz channel. Only STA 1's solicited HE TB PPDU is impacted otherwise.
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Reception of solicited HE TB PPDUs with another HE TB PPDU arriving on RU "
                         "1 during PSDU reception");
     // Another HE TB PPDU arrives at AP on the same RU as STA 1 during PSDU reception
-    Simulator::Schedule(delay + MicroSeconds(50),
-                        &TestUlOfdmaPhyTransmission::SendHeTbPpdu,
+    Simulator::Schedule(delay + MicroSeconds(40),
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu,
                         this,
                         3,
                         1,
@@ -4445,13 +4812,13 @@
     // solicited HE TB PPDUs have been impacted if they are on the same
     // 20 MHz channel. Only STA 2's solicited HE TB PPDU is impacted otherwise.
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Reception of solicited HE TB PPDUs with another HE TB PPDU arriving on RU "
                         "2 during PSDU reception");
     // Another HE TB PPDU arrives at AP on the same RU as STA 2 during PSDU reception
-    Simulator::Schedule(delay + MicroSeconds(50),
-                        &TestUlOfdmaPhyTransmission::SendHeTbPpdu,
+    Simulator::Schedule(delay + MicroSeconds(40),
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu,
                         this,
                         3,
                         2,
@@ -4496,12 +4863,12 @@
     // impacted
     Simulator::Schedule(
         delay,
-        &TestUlOfdmaPhyTransmission::LogScenario,
+        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
         this,
         "Reception of solicited HE TB PPDUs with an HE SU PPDU arriving during the 400 ns window");
     // One HE SU arrives at AP during the 400ns window
     Simulator::Schedule(delay + NanoSeconds(300),
-                        &TestUlOfdmaPhyTransmission::SendHeSuPpdu,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendSuPpdu,
                         this,
                         3,
                         1002,
@@ -4523,13 +4890,13 @@
     // Only send a solicited HE TB PPDU from STA 2 on RU 2 and verify that it has been correctly
     // received
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Reception of solicited HE TB PPDU only on RU 2");
     // Check that STA3 will correctly set its state to CCA_BUSY if in measurement channel or IDLE
     // otherwise
     Simulator::Schedule(delay + m_expectedPpduDuration - NanoSeconds(1),
-                        &TestUlOfdmaPhyTransmission::CheckPhyState,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta3,
                         (m_channelWidth >= MHz_u{40})
@@ -4553,7 +4920,7 @@
     //---------------------------------------------------------------------------
     // Measure the power of a solicited HE TB PPDU from STA 2 on RU 2
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Measure power for reception of HE TB PPDU only on RU 2");
     auto rxPower = DbmToW(
@@ -4582,13 +4949,13 @@
     // limitation enforced
     Simulator::Schedule(
         delay,
-        &TestUlOfdmaPhyTransmission::LogScenario,
+        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
         this,
         "Measure power for reception of HE TB PPDU only on RU 2 with PSD limitation");
     // Configure PSD limitation at 3 dBm/MHz -> 3+13.0103=16.0103 dBm max for 20 MHz,
     // 3+9.0309=12.0309 dBm max for 106-tone RU, no impact for 40 MHz and above
     Simulator::Schedule(delay - NanoSeconds(1), // just before sending HE TB
-                        &TestUlOfdmaPhyTransmission::SetPsdLimit,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetPsdLimit,
                         this,
                         m_phySta2,
                         dBm_per_MHz_u{3});
@@ -4613,7 +4980,7 @@
 
     // Reset PSD limitation once HE TB has been sent
     Simulator::Schedule(delay + m_expectedPpduDuration,
-                        &TestUlOfdmaPhyTransmission::SetPsdLimit,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetPsdLimit,
                         this,
                         m_phySta2,
                         dBm_per_MHz_u{100});
@@ -4634,7 +5001,7 @@
     //---------------------------------------------------------------------------
     // Measure the power of 2 solicited HE TB PPDU from both STAs
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Measure power for reception of HE TB PPDU on both RUs");
     rxPower = DbmToW(
@@ -4659,13 +5026,17 @@
     // Verify that an HE TB PPDU from another BSS has been correctly received (no UL MU transmission
     // ongoing)
     Simulator::Schedule(delay,
-                        &TestUlOfdmaPhyTransmission::LogScenario,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
                         this,
                         "Reception of an HE TB PPDU from another BSS");
     // One HE TB from another BSS (BSS color 2) arrives at AP (BSS color 1)
-    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::SetBssColor, this, m_phyAp, 1);
+    Simulator::Schedule(delay,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetBssColor,
+                        this,
+                        m_phyAp,
+                        1);
     Simulator::Schedule(delay + MilliSeconds(100),
-                        &TestUlOfdmaPhyTransmission::SendHeTbPpdu,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu,
                         this,
                         3,
                         1,
@@ -4676,10 +5047,12 @@
 
     // Verify events data have been cleared
     Simulator::Schedule(delay + MilliSeconds(200),
-                        &TestUlOfdmaPhyTransmission::VerifyEventsCleared,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::VerifyEventsCleared,
                         this);
 
-    Simulator::Schedule(delay + MilliSeconds(500), &TestUlOfdmaPhyTransmission::Reset, this);
+    Simulator::Schedule(delay + MilliSeconds(500),
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::Reset,
+                        this);
     delay += Seconds(1);
 
     //---------------------------------------------------------------------------
@@ -4687,13 +5060,17 @@
     // corrected received
     Simulator::Schedule(
         delay,
-        &TestUlOfdmaPhyTransmission::LogScenario,
+        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario,
         this,
         "Reception of solicited HE TB PPDUs with delay (< 400ns) between the two signals and "
         "reception of an HE TB PPDU from another BSS between the ends of the two HE TB PPDUs");
-    Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::SetBssColor, this, m_phyAp, 1);
+    Simulator::Schedule(delay,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetBssColor,
+                        this,
+                        m_phyAp,
+                        1);
     Simulator::Schedule(delay + m_expectedPpduDuration + NanoSeconds(100),
-                        &TestUlOfdmaPhyTransmission::SendHeTbPpdu,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu,
                         this,
                         3,
                         1,
@@ -4717,33 +5094,38 @@
     Simulator::Run();
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::DoRun()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::DoRun()
 {
-    m_frequency = MHz_u{5180};
+    m_frequency = MHz_u{5955};
     m_channelWidth = MHz_u{20};
     m_expectedPpduDuration = NanoSeconds(292800);
-    NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
-    m_frequency = MHz_u{5190};
+    m_frequency = MHz_u{5965};
     m_channelWidth = MHz_u{40};
     m_expectedPpduDuration = NanoSeconds(163200);
-    NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
-    m_frequency = MHz_u{5210};
+    m_frequency = MHz_u{5985};
     m_channelWidth = MHz_u{80};
     m_expectedPpduDuration = NanoSeconds(105600);
-    NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
-    m_frequency = MHz_u{5250};
+    m_frequency = MHz_u{6025};
     m_channelWidth = MHz_u{160};
     m_expectedPpduDuration = NanoSeconds(76800);
-    NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
+    if (m_modClass >= WIFI_MOD_CLASS_EHT)
+    {
+        m_frequency = MHz_u{6105};
+        m_channelWidth = MHz_u{320};
+        m_expectedPpduDuration = NanoSeconds(62400);
+        RunOne();
+    }
+
     Simulator::Destroy();
 }
 
@@ -4771,10 +5153,7 @@
      * @param payloadSize the size of the payload in bytes
      * @param txDuration the duration of the PPDU
      */
-    void SendHeTbPpdu(uint16_t txStaId,
-                      std::size_t index,
-                      std::size_t payloadSize,
-                      Time txDuration);
+    void SendTbPpdu(uint16_t txStaId, std::size_t index, std::size_t payloadSize, Time txDuration);
     /**
      * Set TRIGVECTOR for HE TB PPDU
      *
@@ -4828,9 +5207,9 @@
      * @param phy the PHY
      * @param expectedState the expected state of the PHY
      */
-    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy, WifiPhyState expectedState);
     /// @copydoc CheckPhyState
-    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy, WifiPhyState expectedState);
 
     /**
      * Reset function
@@ -4855,9 +5234,9 @@
      */
     void RxFailure(Ptr<const WifiPsdu> psdu);
 
-    Ptr<OfdmaSpectrumWifiPhy> m_phyAp;   ///< PHY of AP
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta1; ///< PHY of STA 1
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta2; ///< PHY of STA 2
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phyAp;   ///< PHY of AP
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phySta1; ///< PHY of STA 1
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phySta2; ///< PHY of STA 2
 
     Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
 
@@ -4881,10 +5260,10 @@
 }
 
 void
-TestPhyPaddingExclusion::SendHeTbPpdu(uint16_t txStaId,
-                                      std::size_t index,
-                                      std::size_t payloadSize,
-                                      Time txDuration)
+TestPhyPaddingExclusion::SendTbPpdu(uint16_t txStaId,
+                                    std::size_t index,
+                                    std::size_t payloadSize,
+                                    Time txDuration)
 {
     WifiConstPsduMap psdus;
 
@@ -4900,7 +5279,7 @@
                           false,
                           true};
 
-    HeRu::RuSpec ru(HeRu::RU_106_TONE, index, false);
+    HeRu::RuSpec ru(RuType::RU_106_TONE, index, false);
     txVector.SetRu(ru, txStaId);
     txVector.SetMode(HePhy::GetHeMcs7(), txStaId);
     txVector.SetNss(1, txStaId);
@@ -4917,7 +5296,7 @@
     auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(txStaId, psdu));
 
-    Ptr<OfdmaSpectrumWifiPhy> phy;
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy;
     if (txStaId == 1)
     {
         phy = m_phySta1;
